#ifndef PPCONTROLLER_H
#define PPCONTROLLER_H

#include <map>
#include <vector>
#include <iostream>

// preprocess classes
#include "TomographyStructs.h"
//#include "TomographyStructDefaults.h"
#include "ppDataObject.h"
#include "ppGUI.h"

//ROOT
#include "TGWindow.h"

class ppDataObject;
class ppGUI;

class ppController //: public TObject
{
    public:
        ppController( const int howManyTabs );
        ~ppController();

        bool newData(const unsigned char * inData, const Machine_Config * mcIN, const scopeParam * spIN, const ppStruct * ppsIN, int ID);
        bool changeParam(const Machine_Config * mcIN, const scopeParam * spIN, const ppStruct * ppsIN, int ID);
        void setTrigInfo( int ID, const trigParam* info );

        int analyseData(int ID);

        void getAnalysisResults(std::vector<int>& foranswer, int ID);
        bool getPPDataObjectInfo(ppDataObjectInfo * ans, int ID);
        bool getDAQStruct( DAQStruct* someStruct, int ID );

        bool requestProfiles(std::vector<float >& profiles, profile_data_header_type * profHeader, const profileRequests request, int ID);

        bool isEmpty(int tab);
        bool isNotEmpty(int tab);
        void writeReallyRawData( const char* fileName, int tab);
        bool newDataFromRawFile( const char* fileName, const Machine_Config* machine, const ppStruct* pps, int ID);
        bool newDataFromMingJenFile( const char* filename, const Machine_Config* machine, const ppStruct* pps, int ID );


        void launchPPGUI( const TGWindow *p );

    protected:
    private:

        std::map <int, int> IDMap;
        std::vector< ppDataObject* > dataObjects;

        int numDIFrames;
        int dataCount;

        void ppGUISignalHandler(int signalID);

        // ppGUI stuff
        enum guiButtonsStates {GUIBUTTON, GUIBUTTOFF};
        int actualGUIButtonState;
        ppGUI * ppView;
        void toggleGUIButtons();

    ClassDef(ppController,0);

};

#endif //PPCONTROLLER_H
