#ifndef _TomographyConfig_H_
#define _TomographyConfig_H_

#include "TomographyStructs.h"
//#include "TomographyStructDefaults.h"

bool read_complete_data_header_fromFile( const char* fileName, complete_data_header_type* header );

bool write_complete_data_header_toFile( const char* fileName, complete_data_header_type* header );

bool readMachineConfigFromFile( const char* fileName, Machine_Config* machine );

bool writeMachineConfigToFile( const char* fileName, const Machine_Config machine );

bool readTomographyConfigFromFile( const char* fileName, Tomography_Config* tomography );

bool writeTomographyConfigToFile( const char* fileName, const Tomography_Config tomography );

void copyProfile_data_header_type( const profile_data_header_type* source, profile_data_header_type* destination);

void copyMachine( const Machine_Config* source, Machine_Config* destination);

void copyTomography( const Tomography_Config* source, Tomography_Config* desintation);

void print_profile_data_header_type( profile_data_header_type Head );

void print_Machine_Config( Machine_Config machine );

void print_Tomography_Config( Tomography_Config tomography );

void print_complete_data_header_type(complete_data_header_type Config);

void clear_profile_data_header_type(profile_data_header_type head);

void header_type_to_profile_data_header_type( header_type source, profile_data_header_type destination );

void writeRawDataFile(const char* fileName, const DAQStruct* header, const unsigned char* data);

void mingJenHeaderToDAQStruct( const header_type* mingJenHeader, DAQStruct* TARDISHeader );

#endif
