#ifndef _TomographyDrawing_H_
#define _TomographyDrawing_H_

#include <iostream>
#include <sstream>
#include <TLine.h>
#include <string>
#include <TH2.h>
#include <TF1.h>
#include <TGraph.h>
#include <TGaxis.h>
#include <TCanvas.h>
#include <vector>
#include <algorithm>
#include "TomographyStructs.h"
//#include "TomographyStructDefaults.h"

void SetDipMomGraphStyle(TH1D *h1,TH1D *h2,TGraph *g1,TGraph *g2,TGaxis *axis, Format_Config Format);

void SetDipMomGraphStyle(TH1D *h1,TH1D *h2,TGraph *g1,TGraph *g2,TGaxis *axis);

void SetQuadMomGraphStyle(TH1D *h1,TH1D *h2,TGraph *g1,TGraph *g2,TGaxis *axis, Format_Config Format);

void SetQuadMomGraphStyle(TH1D *h1,TH1D *h2,TGraph *g1,TGraph *g2,TGaxis *axis);

void SetProfFFTGraphStyle(TH1D *h1,TH1D *h2, Format_Config Format);

void SetProfFFTGraphStyle(TH1D *h1,TH1D *h2);

void DipMomGraph( std::vector<double>& profDipMomData, std::vector<double>& reconDipMomData, profile_data_header_type& profHead, TH1D *h1,TH1D *h2,TGraph *g1,TGraph *g2,TGaxis *axis);

void QuadMomGraph( std::vector<double>& profQuadMomData, std::vector<double>& reconQuadMomData, profile_data_header_type& profHead, TH1D *h1,TH1D *h2,TGraph *g1,TGraph *g2,TGaxis *axis);

void ProfPhaseFFTGraph( std::vector<double>& profDipPhaseFFTMag, std::vector<double>& profQuadPhaseFFTMag, profile_data_header_type& profHead, TH1D *h1,TH1D *h2);

void FormatRecon(TH2F* Recon);

void DrawReticule(float centerX, float centerY, float RangeX, float RangeY, int RootColor);

void DrawPhaseSpaceCurve(Double_t BHeight, Double_t BSpc);

void DrawPhaseSpaceCurve(Double_t BHeight, Double_t BSpc, Double_t d_nanosec, int RootColor);

void setGlobalPalette(int paletteNum);

int StatsToTGraph(char* StatFile, TGraph* graph);

int StatsToTGraph(char* StatFile, TGraph* graph, int id);

#endif
