#ifndef _TomographyMath_H_
#define _TomographyMath_H_
#include "TomographyStructs.h"
//#include "TomographyStructDefaults.h"

#define _USE_MATH_DEFINES
#include <math.h>

typedef struct particle
{
  double phi;
  double dE;
} particle;

// particle next_dphi_dE(particle part, double eV, double sPhiS, double phiParam );

// int InsideSeparatrix(particle part, double eKin, double mass, double eV, int h, double gammaT, double phis);

// bool compareActionOfCell( int one, int two );

//Binning
// int ArrayToVector_Pos(int iBin, int jBin, int iSize);

// int WhichBin( double point, double binSize );

//Parameter Calculations 
double gamma(double eKin, double mass);

double beta(double eKin, double mass);

double slip(double eKin, double mass, double gammaT);

double es(double eKin, double mass);

double BucketHeight(double eKin, double mass, double gammaT, double eV, int h);

//Using Machine_Config
double gamma(Machine_Config config);

double beta(Machine_Config config);

double slip(Machine_Config config);

double es(Machine_Config config);

double BucketHeight(Machine_Config config);

double synchrotronHamiltonian(float deV, float phi, Machine_Config* machine);

double SynchrotronPeriod_Turns(Machine_Config config);

double SynchrotronPeriod_Seconds(Machine_Config config);

#endif
