#include "ppBatchPosFinder.h"

    ppBatchPosFinder::ppBatchPosFinder()
    {

    }

    ppBatchPosFinder::~ppBatchPosFinder()
    {
        //dtor
    }
    int ppBatchPosFinder::findBatchStartEndPos(int * frameData, int ptsPerFrame, float bucketlength, float trigY,float trigX)
    {
        int minDat,maxDat;
        bool ans1;

        getMaxMin(frameData,ptsPerFrame,&maxDat,&minDat);
        #ifdef _DEBUG_PREPOCESSER
                std::cout << "\tminDat "<< minDat;
                std::cout << " maxDat "<< maxDat << std::endl;
                std::cout << std::endl;
        #endif

         bucketLength=(double)bucketlength;
        //double rms = rmsFrame(frameData,ptsPerProfile);
        float trigy = minDat+((maxDat-minDat)/trigY);
        float trigx = trigX*bucketLength;
        #ifdef _DEBUG_PREPOCESSER
            std::cout << "\ttrigy  = "<< trigy;
            std::cout << " trigx =  "<< trigx << std::endl;
            std::cout << std::endl;
        #endif
        //std::cout << "trigy " << trigy << std::endl;
        //std::cout << " trigx " << trigx << std::endl;
        getBatchStartEndPos(frameData,ptsPerFrame,trigy,trigx);

        ans1  = Resize_Local_Batch_Pos_Vectors(ptsPerFrame);
        if(ans1)
        {
            return findStructure(ptsPerFrame);
        }
        return -1;
    }


    int ppBatchPosFinder::findStructure(int ptsPerFrame) /// En-coding structure works assuming there are never more than 9 batches ... (!)
    {
        int dataStructure;
        if( (int)localBatchStartPos.size() == 0 && (int)localBatchEndPos.size() == 0 )
        {
            //dataStructure = 0;
            return 0;
        }
        if( localBatchStartPos[0] == 0 && localBatchEndPos[0] == ptsPerFrame -1 ) // /special case of partial batch with no start or end
        {
            //dataStructure = 10;
            return 10;
        }


        int numbatches;
        int test = abs((int)localBatchStartPos.size()-(int)localBatchEndPos.size());
        switch(test)
        {
            case 0:

                numbatches=localBatchStartPos.size();
                if( localBatchEndPos[0] < localBatchStartPos[0] )
                {//Partial symmetric = 10
                    dataStructure = 10 + numbatches-1;
                }
                else
                {//Full Symmetric = 20
                    dataStructure = 20 + numbatches;
                }

                return dataStructure;
            case 1:

                if((int)localBatchStartPos.size()>(int)localBatchEndPos.size())
                {
                    numbatches = localBatchStartPos.size()-1;
                }
                else {
                    numbatches = localBatchEndPos.size()-1;
                }

                if( localBatchEndPos[0] < localBatchStartPos[0] )
                {//Assymetric Partial bacth at start = 30
                    dataStructure = 30 + numbatches;
                }
                else
                {//Asymmetric partial batch at end = 40
                    dataStructure = 40 + numbatches;
                }
                    return dataStructure;
            default:
                    //dataStructure = 0;
                    return -1;
        }
    }


    void ppBatchPosFinder::getBatchStartPos(std::vector<int> & batchStartPos)
    {
        batchStartPos.resize(localBatchStartPos.size());
        for(int i = 0 ; i <localBatchStartPos.size();++i)
        {
            batchStartPos[i]=localBatchStartPos[i];
            //std::cout << "batchStartPos[i]  "<< batchStartPos[i] << "  localBatchStartPos[i]  "<< localBatchStartPos[i] << std::endl;
        }
    }
    void ppBatchPosFinder::getBatchEndPos(std::vector<int> & batchEndPos)
    {
            batchEndPos.resize(localBatchEndPos.size());
            for(int i =0 ; i <localBatchEndPos.size();++i)
            {
                batchEndPos[i]=localBatchEndPos[i];
            }

    }

    void ppBatchPosFinder::getBatchStartEndPos(int * frameData,int ptsPerFrame, float trigY, float trigX)
    {
        localBatchStartPos = std::vector<int> (20); /// assume there can only be 6 batches! may need checking
        localBatchEndPos = std::vector<int> (20); /// assume there can only be 6 batches! may need checking
        /// loop along data looking for bunch start and ends and see how far they were from the last one, assume "large"  gaps are batches
        int laststartpos = 0;
        int numstartpos = 0;
        //int lastStartPos;
        int lastendpos = 0;
        int numendpos = 0;
        int numendBatchpos = 0;
        for(int i = 0 ; i < ptsPerFrame-1 ; ++i) /// this is done in a single loop which makes it harder to read...
        {
           //std::cout << (float)(*(frameData+i)) << "  " <<  (float)(*(frameData+i+1))   <<  std::endl;

            /// look for start positions
            if(  ( (*(frameData+i)) <= trigY ) && ( ( *(frameData+i+1)) > trigY )   )
            {

                if( i - laststartpos > trigX  )
                {
                    localBatchStartPos[numstartpos]=i;
                    //std::cout << "localBatchStartPos[startk] "<< localBatchStartPos[numstartpos]<< std::endl;
                    numstartpos++;
                }
                laststartpos = i;
            }
            /// look for end positions
            else if(  ( (*(frameData+i)) >= trigY ) && ( ( *(frameData+i+1)) < trigY )    )
            {
                if(numendpos != 0)
                {
                    if( (i - lastendpos) > trigX)
                    {
                        localBatchEndPos[numendBatchpos]=lastendpos;
                        //std::cout << "localBatchEndPos[numendBatchpos] "<< localBatchEndPos[numendBatchpos]<< std::endl;
                        ++numendBatchpos;
                    }
                }
                ++numendpos;
                lastendpos = i;
            }
        }
        if( lastendpos+trigX < ptsPerFrame) /// catch endpos near end of data
        {
            localBatchEndPos[numendBatchpos]=lastendpos;
        }
        /// for the case where bunches are find but no batch start and end pos
        if(numendpos > 0 && localBatchStartPos[0] == 0 && localBatchEndPos[0] == 0)// assume there is bunches but no start or end bos
        {
            localBatchStartPos[0] = -1;///should be zero but it will then fail the resizing later
            localBatchEndPos[0] = ptsPerFrame-1; /// and it's a special case
        }
        /*for(int j=0;j<5;++j)
        {
            std::cout << "localBatchStartPos[j] "<< localBatchStartPos[j]<< std::endl;
            std::cout << "localBatchEndPos[j] "<< localBatchEndPos[j]<< std::endl;
        }
        */

    }

bool ppBatchPosFinder::Resize_Local_Batch_Pos_Vectors(int ptsPerFrame) /// Resize the vector, and also +/- 2.5 bucketlength to each point, to try and make sure we get any missed beam
{
    float startendposextra = 2.5*bucketLength;
    #ifdef _DEBUG_PREPOCESSER
    std::cout << "\tbatchPosFinder Finds:" <<std::endl;
    std::cout << std::endl;
    #endif

    int temp=0;
    bool ans = false;
    for(int i = 0; i < localBatchStartPos.size() ; ++i)
    {
        if(localBatchStartPos[i] != 0)
        {
            #ifdef _DEBUG_PREPOCESSER
                std::cout << "\t Start Pos = " << localBatchStartPos[i];
            #endif
            ++temp;
            localBatchStartPos[i]-= (int)floor( 2.5*bucketLength);
            #ifdef _DEBUG_PREPOCESSER
                std::cout << ", Start pos - extra = " << localBatchStartPos[i];
            #endif
            if(localBatchStartPos[i] < 0)
            {
                localBatchStartPos[i] = 0;
            }
        }
    }
        #ifdef _DEBUG_PREPOCESSER
            std::cout << std::endl;
        #endif
    if(temp>0)
    {
        ans = true;
        localBatchStartPos.resize(temp);
    }
    temp=0;
    for(int i=0;i<localBatchEndPos.size();++i)
    {
        if(localBatchEndPos[i]>0)
        {
            #ifdef _DEBUG_PREPOCESSER
                std::cout << "\t End pos = " << localBatchEndPos[i];
            #endif
            ++temp;
            localBatchEndPos[i]+= (int)floor(2.5*bucketLength);
            #ifdef _DEBUG_PREPOCESSER
                std::cout << ", end pos + extra = " << localBatchEndPos[i];
            #endif
            if( localBatchEndPos[i] > ptsPerFrame-1)
            {
                localBatchEndPos[i] = ptsPerFrame-1;
            }
        }
    }
    if(temp>0) ans = true;
    {
    #ifdef _DEBUG_PREPOCESSER
        std::cout << std::endl;
        std::cout<< std::endl;
        std::cout<< "\treturning " << ans <<  std::endl;
        std::cout<< std::endl;
    #endif
        localBatchEndPos.resize(temp);
    }
    //std::cout << "localBatchStartPos.size() "<< localBatchStartPos.size() << std::endl;
    // std::cout << "localBatchEndPos.size() "<< localBatchEndPos.size() << std::endl;
    // for(int i = 0; i < localBatchStartPos.size(); ++i)
    // std::cout << "localBatchStartPos[i] "<< localBatchStartPos[i] << std::endl;
    // for(int i = 0; i < localBatchEndPos.size(); ++i)
    // std::cout << "localBatchEndPos[i] "<< localBatchEndPos[i] << std::endl;
    return ans;
}

void ppBatchPosFinder::getMaxMin(int * frameData,int ptsPerFrame,int * Max, int * Min)
{
    int i,max,min;
    max=0;
    min=*(frameData);
    for(i = 0 ; i < ptsPerFrame ; ++i)
    {
        if(*(frameData+i) > max ) max = *(frameData+i);
        if(*(frameData+i) < min ) min = *(frameData+i);
    }
    *Max = max;
    *Min = min;
}


double ppBatchPosFinder::rmsFrame(int * frameData,int ptsPerFrame) /// not used anymore....
{
    double temp,temp2;
    temp=0;
    temp2=0;
    for(int i = 0 ; i < ptsPerFrame; ++i )//10;++i)//
    {
        //temp=pow((double)(*frameData)[i],(double)2);
        temp   = pow((double)*(frameData+i),(double)2);
        temp2 += temp;
        //std::cout << "temp "<< temp << std::endl;
    }
    double meansq = temp2/((double)ptsPerFrame);
    //std::cout << "meansq "<< meansq << std::endl;
    double ans = sqrt(meansq);
    //std::cout << "rms "<< ans << std::endl;
    return ans;
}










































