#ifndef PPBATCHPOSFINDER_H
#define PPBATCHPOSFINDER_H

#include <iostream>
#include <fstream>
#include <vector>
#include <math.h>

class ppBatchPosFinder
{
    public:
        ppBatchPosFinder();
        ~ppBatchPosFinder();

        int findBatchStartEndPos(int * frameData, int ptsPerFrame, float bucketlength, float trigY, float trigX);


        void getBatchEndPos(std::vector<int> & batchStartPos);
        void getBatchStartPos(std::vector<int> & batchEndPos);

    protected:
    private:


        void getMaxMin(int * frameData,int ptsPerFrame, int * Max, int * Min);
        void getBatchStartEndPos(int * frameData,int ptsPerFrame, float trigY, float trigX);
        bool Resize_Local_Batch_Pos_Vectors(int ptsPerFrame);

        // double rmsFrame(const std::vector<int> * frameData,int ptsPerProfile);
        double rmsFrame(int * frameData, int ptsPerFrame);


        double bucketLength;
        bool globalAns;

        /// Local preProcesser Pinter
        //const std::vector<long int> * sumFrames;


        std::vector<int> localBatchStartPos;
        std::vector<int> localBatchEndPos;

        int findStructure(int ptsPerProfile);
        //int dataStructure; //the format of the dat is encoded in this

        void Get_Batch_Start_Positions();

    //ClassDef(ppBatchPosFinder,0);
};

#endif // PPBATCHPOSFINDER_H
