#include "ppDIFrameFinder.h"

    ppDIFrameFinder::ppDIFrameFinder()
    {

    }
    ppDIFrameFinder::~ppDIFrameFinder()
    {
        //dtor
    }
    bool ppDIFrameFinder::findDIFrames(std::vector<int> & data, const  int numFrames,const  int ptsPerFrame, const float DIFrameTrigger,int *numDIFrames)
    {
        totalFrame(data, numFrames,ptsPerFrame);
        dTotalFrame();
        double rms =rmsLocalVector();
        //std::cout << "rms "<< rms << std::endl;
        //std::cout << "(double)DIFrameTrigger "<< (double)DIFrameTrigger << std::endl;
        double trig = rms*(double)DIFrameTrigger;
        //std::cout << "trig "<< trig << std::endl;
        bool ans = testForDI(trig);
        *numDIFrames = (int)localvector.size();
        //for(int i= 0; i<localvector.size();++i)
        //std::cout << "localvector[i] "<< localvector[i] << std::endl;

        return ans;
    }

    void ppDIFrameFinder::getDIFrames(std::vector<int> & DIFrames)
    {
        for(int i =0 ; i <localvector.size();++i)
        {
            DIFrames[i]=(int)localvector[i];
        }

    }
    bool ppDIFrameFinder::testForDI(double trig)
    {
        int i;
        int count = 0;
        for( i = 0 ; i < localvector.size()-1 ; ++i) /// don't include the last frame
        {
            if( abs((double)localvector[i]) > trig )
            {
                localvector[count] = i;
                count++;
            }
        }
        localvector.resize(count);
        //for(int i= 0; i<localvector.size();++i)
        //std::cout << "localvector_1[i] "<< localvector[i] << std::endl;

        int count2 = 1;
        if(count > 0)
        {
            localvector[0]=localvector[0]+1;
            for( i = 0 ; i < localvector.size()-1 ; ++i)
            {
                if( (localvector[i+1]-localvector[i]) > 1 )
                {
                    localvector[count2]=localvector[i+1]+1;
                    ++count2;
                }
            }
            localvector.resize(count2);
            //for(int i= 0; i<localvector.size();++i)
            //std::cout << "localvector_2[i] "<< localvector[i] << std::endl;
            return true;
        }
        else
        {
            return false;
        }

    }

    void ppDIFrameFinder::totalFrame(std::vector<int> & data, const  int numFrames,const  int ptsPerFrame)
    {
        long int tot;
        localvector = std::vector<long int>(numFrames);
        for(int i= 0; i<numFrames;++i)
        {
            tot = 0;
            for(int j=0;j<ptsPerFrame;++j)
            {
                tot+=data[i*ptsPerFrame+j];
            }
            localvector[i]=tot;
        }
        //for(int i= 0; i<10;++i)
        //std::cout << "totalFrame[i] "<< localvector[i] << std::endl;
    }
    void ppDIFrameFinder::dTotalFrame()
    {
        long int temp;
        for(int i= 0; i<localvector.size()-1;++i)
        {

            temp=localvector[i+1]-localvector[i];
            localvector[i]=temp;
        }
        //for(int i= 0; i<10;++i)
        //std::cout << "dSumEachFrame[i] "<< localvector[i] << std::endl;
    }
    double ppDIFrameFinder::rmsLocalVector()
    {
        double temp  = 0;
        double temp2 = 0;
    
        for(int i = 0 ; i < localvector.size()-1; ++i )//10;++i)//
        {
            temp   = pow((double)localvector[i],(double)2);
            temp2 += temp;
            //std::cout << "temp "<< temp << std::endl;
        }
        double meansq = temp2/((double)localvector.size()-1);
        //std::cout << "meansq "<< meansq << std::endl;
        double ans = sqrt(meansq);
        //std::cout << "rms "<< ans << std::endl;
        return ans;
    }

