#include "ppDataObject.h"

// ppDataObject::ppDataObject(const std::vector<unsigned char>& inData, const ppStruct * ppS)
//ppDataObject::ppDataObject(const unsigned char * inData, const ppStruct * ppS)
ppDataObject::ppDataObject(const unsigned char * inData, const Machine_Config * mcIN, const scopeParam * spIN, const ppStruct * ppsIN)
{
    rawData.clear();
    reallyRawData.clear();
    dataObjectInfo.mc  = *mcIN;
    dataObjectInfo.sp  = *spIN;
    dataObjectInfo.pps = *ppsIN;

    // localPPP = *ppS;
    dataObjectInfo.bucketLength = 1e9 / ( dataObjectInfo.sp.interval * dataObjectInfo.mc.RF_f );

    int ptsPerTurn;
    // convert inData to ints
    ptsPerTurn = (int)floor(  dataObjectInfo.mc.h / (  dataObjectInfo.mc.RF_f * dataObjectInfo.sp.interval * 1e-9 ) ); // check the # pts is less than a turn only use data up to 1 turn, a fairly arbitrary decission

    if( ptsPerTurn < dataObjectInfo.sp.ptsPerFrame )
    {
        //rawData = std::vector<int>( ptsPerTurn * dataObjectInfo.sp.numFrames ); /// Convert indata to ints
        rawData.resize( ptsPerTurn * dataObjectInfo.sp.numFrames, 0 ); /// Convert indata to ints
        reallyRawData.resize( ptsPerTurn * dataObjectInfo.sp.numFrames, 0 ); /// Convert indata to ints
        for( int i = 0; i < dataObjectInfo.sp.numFrames; ++i )
        {
            for(int j = 0; j < ptsPerTurn; ++j )
            {
                unsigned char dummy = *(inData + i * dataObjectInfo.sp.ptsPerFrame + j );
                rawData[ j + i * ptsPerTurn ]       = (int)dummy;//*(inData + i * dataObjectInfo.sp.ptsPerFrame + j );
                reallyRawData[ j + i * ptsPerTurn ] = dummy;
                //rawData[j + i * ptsPerTurn ]=(int)inData[ i*localPPP.ptsPerFrame+j];
            }
        }
        dataObjectInfo.sp.ptsPerFrame = ptsPerTurn;
    }else{
        //rawData = std::vector<int>( dataObjectInfo.sp.numFrames * dataObjectInfo.sp.ptsPerFrame ); /// Convert indata to ints
        rawData.resize( dataObjectInfo.sp.numFrames * dataObjectInfo.sp.ptsPerFrame  , 0 );
        reallyRawData.resize( dataObjectInfo.sp.numFrames * dataObjectInfo.sp.ptsPerFrame  , 0 );
        for(int i = 0 ; i < rawData.size(); ++i)
        {
            unsigned char dummy = *(inData + i);
            rawData[i]       = (int)dummy;
            reallyRawData[i] = dummy;
        }

    }
    //for(int i = 49 ; i< 59 ;++i) std::cout << "rawData " << i << " " << rawData[i] <<  std::endl;
    //ofstream outbin( "/usr/local/cbs_files/cns_write/pa4219/procdata.bin",std::ios::out|std::ios::binary);
    //outbin.write( (const char*) &rawData[0], rawData.size()*sizeof(int));
    //outbin.close;
    //ofstream outbin2( "/usr/local/cbs_files/cns_write/pa4219/passed.bin",std::ios::out|std::ios::binary);
    //outbin2.write((char *)&inData[0], rawData.size());
    //outbin2.close;
}


ppDataObject::ppDataObject( const char* filename, const Machine_Config* machine, const ppStruct* pps)
{///newDataFromMingJenFile
//    DAQStruct thisDAQ;
//    header_type mingJenHeader;
//    std::ifstream inFile( filename, std::ios::in | std::ios::binary );
//
//    inFile.seekg (0, inFile.end);
//    int realSize = inFile.tellg();
//    inFile.seekg (0, inFile.beg);
//
//    bool didRead = false;
//
//    if( realSize >= sizeof( header_type ) ) // make sure it's at least as big as a header
//    {
//        //Don't read in a struct this way unless it's packed!
//        inFile.read( (char*)&mingJenHeader, sizeof(header_type) );
//        long NPointsTot = mingJenHeader.rtd_len * mingJenHeader.rtd_nrec; //Length of one bunch*DataFrames
//        long dataSize   =  NPointsTot * sizeof(unsigned char);
//
//        //MingJen adds time stamp for each frame at end. So you need to account for that
//        //For now as long as real size is larger than data proceed
//        if( realSize >= dataSize + sizeof(header_type) )
//        {
//            //Read all data into reallyRawData.
//            inFile.seekg( sizeof( header_type ), inFile.beg );
//            std::vector<unsigned char> reallyRawData( NPointsTot );
//            inFile.read( (char*)&reallyRawData[0], NPointsTot ); //dataSize );
//
//            mingJenHeaderToDAQStruct( &mingJenHeader, &thisDAQ );
//
//            newData( &reallyRawData[0], machine, &thisDAQ.DAQScope, pps, ID );
//            setTrigInfo( ID, &thisDAQ.DAQTrig );
//
//            didRead = true;
//        }
//    }
//    #ifdef _STANDALONE_VERBOSE
//        if(didRead == false) std::cout << "File format incorrect or file is corrupt."  << std::endl;
//    #endif
//
//    inFile.close();
//    return didRead;
}




ppDataObject::~ppDataObject()
{
}

void ppDataObject::changeParam(const Machine_Config * mcIN, const scopeParam * spIN, const ppStruct * ppsIN)
{
    dataObjectInfo.mc  = *mcIN;
    dataObjectInfo.sp  = *spIN;
    dataObjectInfo.pps = *ppsIN;

    int ptsPerTurn = (int)floor(  dataObjectInfo.mc.h / (  dataObjectInfo.mc.RF_f * dataObjectInfo.sp.interval * 1e-9 ) );
    if( ptsPerTurn < dataObjectInfo.sp.ptsPerFrame) dataObjectInfo.sp.ptsPerFrame=ptsPerTurn;

    dataObjectInfo.bucketLength= 1e9 /( dataObjectInfo.sp.interval * dataObjectInfo.mc.RF_f);
    //std::cout << " bucketlength " << bucketlength << std::endl;
}

void ppDataObject::setTrigInfo(const trigParam* info)
{
    dataObjectInfo.ppTrigInfo = *info;
}

void ppDataObject::getHeaderTrigParams( profile_data_header_type* head )
{
    head -> delay          = dataObjectInfo.ppTrigInfo.trigDelay;
    head -> turns_per_trig = dataObjectInfo.ppTrigInfo.turnsDelay;
    head -> num_bunches    = dataObjectInfo.bunchMids.size();
    head -> num_frames     = dataObjectInfo.requestFrameEnd - dataObjectInfo.requestFrameStart;
    //head -> ptsperprofile  = dataObjectInfo.ppTrigInfo.turnsDelay;


}

/// ______               __            _______               __               __
///|   __ \.---.-.-----.|__|.----.    |   _   |.-----.---.-.|  |.--.--.-----.|__|.-----.
///|   __ <|  _  |__ --||  ||  __|    |       ||     |  _  ||  ||  |  |__ --||  ||__ --|
///|______/|___._|_____||__||____|    |___|___||__|__|___._||__||___  |_____||__||_____|
///                                                             |_____|
/// This looks for the signal, "injection" frames (actually looks for step changes in signal and then finds batch start and end
/// positions for each injection frame. Add other methods to the finder classes
int ppDataObject::analyseData()
{
    #ifdef _PREPOCESSER_VERBOSE
        std::cout << "\t\t***** Analyse Data *****"<< std::endl;
        std::cout << std::endl;
    #endif

    bool findSigANS,findDIFramesANS,findBatchPosANS;
    findSigANS = findDIFramesANS = findBatchPosANS = false;
    #ifdef _PREPOCESSER_VERBOSE
        std::cout << "\t === Finding Frames with Signal === " << std::endl;
        std::cout << std::endl;
    #endif

    findSigANS = findSignal(); // LOOK FOR SIGNAL IN DATA

    int returnValue = 0;
    if( findSigANS )
    {

        int numDIFound;
        #ifdef _PREPOCESSER_VERBOSE
            std::cout << "\t === Finding Injection Frames === " << std::endl;
            std::cout << std::endl;
        #endif
        findDIFramesANS = findDIFrames( &numDIFound ); /// look for large changes in frame intensity
        #ifdef _PREPOCESSER_VERBOSE
        std::cout << "Number of injection frames found:" << findDIFramesANS  << std::endl;
        std::cout << std::endl;
        #endif

        if( findDIFramesANS )
        {
            #ifdef _PREPOCESSER_VERBOSE
                std::cout << "\t === Finding Batch Start End Positions ===" << std::endl;
                std::cout << std::endl;
            #endif
            findBatchPosANS = findBatchPos();
            returnValue = dataObjectInfo.dataStructures.size();

        }else{
            #ifdef _PREPOCESSER_VERBOSE
                std::cout << "no inj frames " << std::endl;
                std::cout << std::endl;
            #endif
            returnValue = 0;
        }

    }else{
        #ifdef _PREPOCESSER_VERBOSE
            std::cout << "no signal found " << std::endl;
            std::cout << std::endl;
        #endif
        returnValue = 0;
    }
    //if(ans3)std::cout << "ans3 true " << std::endl;
    return returnValue;
}

bool ppDataObject::findSignal()
{
    //std::cout << "findSignal() " << std::endl;
    bool ans;
    ppFrameSignalFinder *frameSignalFinder;
    frameSignalFinder = NULL;
    frameSignalFinder = new ppFrameSignalFinder( dataObjectInfo.sp.numFrames, dataObjectInfo.sp.ptsPerFrame);

    ans = frameSignalFinder->findSignal(rawData, dataObjectInfo.pps.sigTrig, &(dataObjectInfo.sigStartFrame), &(dataObjectInfo.sigEndFrame) );

    delete frameSignalFinder;

    #ifdef _PREPOCESSER_VERBOSE
        std::cout << "ppFrameSignalFinder finds:" << std::endl;
        std::cout << std::endl;
        std::cout << "\tStart Frame = " << dataObjectInfo.sigStartFrame << ", End Frame = "  << dataObjectInfo.sigEndFrame << std::endl;
        std::cout << std::endl;
    #endif

    return ans;
}

bool ppDataObject::findDIFrames( int * numDIFound)
{
    //std::cout << "findDIFrames() " << std::endl;
    bool ans;
    ppDIFrameFinder * DIFrameFinder;
    DIFrameFinder = NULL;
    DIFrameFinder = new ppDIFrameFinder();
    ans = DIFrameFinder -> findDIFrames( rawData, dataObjectInfo.sp.numFrames, dataObjectInfo.sp.ptsPerFrame, dataObjectInfo.pps.dITrig, &(dataObjectInfo.numDIFrames));

    if(ans)
    {
        std::vector<int> DIFrames(dataObjectInfo.numDIFrames);
        DIFrameFinder -> getDIFrames(DIFrames);
        /// find the union of  {dataObjectInfo.sigStartFrame,dataObjectInfo.sigEndFrame} and injFrames
        int list1[2] = {dataObjectInfo.sigStartFrame,dataObjectInfo.sigEndFrame};
        int * list2;
        list2 = new int [DIFrames.size()];
        for(int i=0;i<DIFrames.size();++i)
        {
            list2[i]=DIFrames[i];
        }
        std::vector<int>::iterator it;
        dataObjectInfo.DISigFrames = std::vector<int>(DIFrames.size()+2);
        it = std::set_union (list1, list1+2, list2, list2 + DIFrames.size(), dataObjectInfo.DISigFrames.begin());
        dataObjectInfo.DISigFrames.resize( it - dataObjectInfo.DISigFrames.begin() );
        delete list2;
        #ifdef _PREPOCESSER_VERBOSE
            std::cout << "Found " << dataObjectInfo.DISigFrames.size()-1 << " Injection Frame(s)" << std::endl;
            for(int i=0; i < dataObjectInfo.DISigFrames.size(); ++i)
            {
                std::cout << "dataObjectInfo.DISigFrames[i] " << dataObjectInfo.DISigFrames[i] << std::endl;
            }
        #endif
        *numDIFound=dataObjectInfo.DISigFrames.size()-1; /// pass back a number of injections found
        }else{
            /// didn't find DI changes, but... this function is run if signal is found, so assume:
            #ifdef _PREPOCESSER_VERBOSE
                std::cout << "Found Zero Injection Frames, Checking Signal Frames" << std::endl;
            #endif
            dataObjectInfo.DISigFrames    = std::vector<int>(2);
            dataObjectInfo.DISigFrames[0] = dataObjectInfo.sigStartFrame ;
            dataObjectInfo.DISigFrames[1] = dataObjectInfo.sigEndFrame ;
    }
    //for(int i = 0; i < dataObjectInfo.DISigFrames.size(); ++i)
    //std::cout << "dataObjectInfo.DISigFrames[i] " << dataObjectInfo.DISigFrames[i] << std::endl;
    delete DIFrameFinder;
    return true;
}

bool ppDataObject::findBatchPos()
{//std::cout << "findBatchPos() " << std::endl;
    bool ans;
    ans = false;

    int dataStructure;

    ppBatchPosFinder * batchPosFinder;
    batchPosFinder = NULL;
    batchPosFinder  = new ppBatchPosFinder();

    dataObjectInfo.dataStructures = std::vector<int> (dataObjectInfo.DISigFrames.size()-1);

    /// a vector of vectors holding the batch start/end positions for each Inj
    dataObjectInfo.batchStartPos = std::vector< std::vector<int> > (dataObjectInfo.DISigFrames.size()-1, std::vector<int>(10)); // assuming no more than 9 batches
    dataObjectInfo.batchEndPos = std::vector< std::vector<int> > (dataObjectInfo.DISigFrames.size()-1, std::vector<int>(10));// assuming no more than 9 batches

    for(int i = 0; i < dataObjectInfo.DISigFrames.size()-1; ++i)
    {
        #ifdef _PREPOCESSER_VERBOSE
                std::cout << "\tLooking For BatchPositions in Frame: " << dataObjectInfo.DISigFrames[i] <<  std::endl;
                std::cout << "\t(position in rawdata list = " <<  dataObjectInfo.sp.ptsPerFrame * dataObjectInfo.DISigFrames[i] <<  " = ";
                std::cout << rawData[ dataObjectInfo.sp.ptsPerFrame * dataObjectInfo.DISigFrames[i]] << ")" << std::endl;
                std::cout << std::endl;
        #endif
        //rawDataPtr = &rawData[ localPPP.ptsPerFrame * dataObjectInfo.DISigFrames[i]]; // ptr to start of frame
        dataStructure = batchPosFinder -> findBatchStartEndPos( &rawData[ dataObjectInfo.sp.ptsPerFrame * dataObjectInfo.DISigFrames[i]]  , dataObjectInfo.sp.ptsPerFrame, dataObjectInfo.bucketLength, dataObjectInfo.pps.bunchTrig, 2);// 2 is trigx
        if(dataStructure != -1){ // -1 would be an error, if not update local vectors...
            #ifdef _PREPOCESSER_VERBOSE
                std::cout << "\tConfirm ppBatchPosFinder Finds Answers in ppdataObject:" <<  std::endl;
                std::cout << std::endl;
            #endif

            ans = true; // something has been found...
            // std::cout << " dataStructure HERE  " << dataStructure << std::endl;
            batchPosFinder -> getBatchStartPos(dataObjectInfo.batchStartPos[i]);
            batchPosFinder -> getBatchEndPos(dataObjectInfo.batchEndPos[i]);
            dataObjectInfo.dataStructures[i] = dataStructure;
        }
        else{
            #ifdef _PREPOCESSER_VERBOSE
                std::cout << "\tppBatchPosFinder Failed" <<  std::endl;
                std::cout << std::endl;
            #endif
        }
    }
    #ifdef _PREPOCESSER_VERBOSE
    for(int k=0;k<dataObjectInfo.dataStructures.size();++k)
    {
       std::cout << "\tBatch Start Positions: dataObjectInfo.batchStartPos  " << std::endl;
       std::cout << "\t";
       for(int i=0;i<dataObjectInfo.batchStartPos[k].size();++i)
       std::cout << " " << dataObjectInfo.batchStartPos[k][i];
       std::cout << std::endl;
       std::cout << "\tBatch End Positions: dataObjectInfo.batchEndPos  " << std::endl;
       std::cout << "\t";
       for(int i=0;i<dataObjectInfo.batchEndPos[k].size();++i)
       std::cout << " " << dataObjectInfo.batchEndPos[k][i];
       std::cout << std::endl;
       std::cout << "dataObjectInfo.dataStructures  "<< dataObjectInfo.dataStructures[k] << std::endl;

        decodeBatchPosDataStructures();
    }
    #endif
    delete batchPosFinder;

    return ans;
}
void ppDataObject::decodeBatchPosDataStructures()
{
    int dspart1, dspart2, test;
    for(int k=0;k<dataObjectInfo.dataStructures.size();++k)
    {
        dspart2 = dataObjectInfo.dataStructures[k]%10;
        dspart1 = floor((float)dataObjectInfo.dataStructures[k]/10.0);
        std::cout << std::endl;
        std::cout << "\tDe-Code "<< dspart1 << "    " << dspart2 << std::endl;
         std::cout << std::endl;
        switch(dspart1)
        {
            case 1:
                if(dspart2 == 0)
                {
                    std::cout <<  "1 = DataSet with partial start and end, 0 full batches available to reconstruct." << std::endl;
                }else{
                    std::cout <<  "1 = DataSet with partial start and end," << dspart2 << " full batches available to reconstruct." << std::endl;
                }
                break;
            case 2:
                std::cout << "2 = Full Symmetric DataSet, with "<< dspart2 << " full batche(s) available to reconstruct." << std::endl;
                break;
            case 3:
                 std::cout << "3 = Asymmetric DataSet, with partial batch at start, "<< dspart2 << " full batche(s) available to reconstruct." << std::endl;
                //std::cout << "Asymmetric DataSet, with partial batch at start, ", dspart2, " full batches available to reconstruct." << std::endl;
                break;
            case 4:
                std::cout << "4 = Asymmetric DataSet, with partial batch at end, "<< dspart2 << " full batche(s) available to reconstruct." << std::endl;

               // std::cout << "Asymmetric DataSet, with partial batch at end, ", dspart2, " full batches available to reconstruct." << std::endl;
                break;
            default:
                std::cout << "Major Error." << std::endl;

        }
    }// for loop


}


void ppDataObject::getAnalysisResults( std::vector<int>& foranswer )
{ /// fills passed vector with DI frame number and the encoded beam structure
    foranswer.resize(dataObjectInfo.dataStructures.size()+dataObjectInfo.DISigFrames.size());
    int j = 0;
    for(int i = 0 ; i < dataObjectInfo.dataStructures.size() ; ++i  )
    {
        foranswer[j]=dataObjectInfo.DISigFrames[i];
        ++j;
        foranswer[j]=dataObjectInfo.dataStructures[i];
        ++j;
    }
    foranswer[j]=dataObjectInfo.DISigFrames[dataObjectInfo.DISigFrames.size()-1];
       //for(int i=0;i<foranswer.size();++i)
      //std::cout << " " << foranswer[i] << std::endl;
}


/// ______              ___ __ __             ______                                 __
///|   __ \.----.-----.'  _|__|  |.-----.    |   __ \.-----.-----.--.--.-----.-----.|  |_.-----.
///|    __/|   _|  _  |   _|  |  ||  -__|    |      <|  -__|  _  |  |  |  -__|__ --||   _|__ --|
///|___|   |__| |_____|__| |__|__||_____|    |___|__||_____|__   |_____|_____|_____||____|_____|
///                                                           |__|
bool ppDataObject::profilesRequestHandler(std::vector<float >& profiles, profile_data_header_type * profHeader, const profileRequests request)
{
    bool doesRequestExist;
    bool bunchmidfindersucces;
    bool doprofilesexist;

    doesRequestExist = dataExists(request); //Why is this not coming from the ppS?

    if( doesRequestExist )
    {
        #ifdef _PREPOCESSER_VERBOSE
            std::cout << std::endl;
            std::cout << "\tRequsted profiles exist, finding bucket/bunch mid positions" <<  std::endl;
            std::cout << std::endl;
        #endif

        getSumFrame();
        ppBunchMidFinder *bunchMidFinder = new ppBunchMidFinder( dataObjectInfo.bucketLength, dataObjectInfo.pps.bunchChargeFull, dataObjectInfo.pps.bunchChargePartial, dataObjectInfo.pps.ptsPerProfile );
        dataObjectInfo.bunchMids         = std::vector<float > ( dataObjectInfo.mc.h );///assume can't be more than "harmonic number" profiles...
        bunchMidFinder -> getBunchMids( sumFrames, dataObjectInfo.pps.bunchMidMethod, dataObjectInfo.bunchMids );// the answers are positions relative to sumFrames, not rawData!
        for(int i = 0; i < dataObjectInfo.bunchMids.size(); ++i )
        {

            dataObjectInfo.bunchMids[i] += dataObjectInfo.requestBatchStart;
        }
        #ifdef _PREPOCESSER_VERBOSE
        std::cout << "dataObjectInfo.requestBatchStart:" << dataObjectInfo.requestBatchStart << std::endl;
        std::cout << "\tAdjused bunchMids including " << std::endl;
        for(int i = 0; i < dataObjectInfo.bunchMids.size(); ++i )
        {

             std::cout << dataObjectInfo.bunchMids[i] << " ";
        }
         std::cout << std::endl;
          std::cout << std::endl;
        #endif
        getProfiles( profiles, profHeader );
    }
    else{
        #ifdef _PREPOCESSER_VERBOSE
        std::cout << std::endl;
            std::cout << "Requsted profiles don't exist, should through a false to mastercontrol here" <<  std::endl;
            std::cout << std::endl;
        #endif
    }

    return doesRequestExist;
}
bool ppDataObject::dataExists(const profileRequests userRequest)
{
    profileRequests request = (userRequest == kRequestDefault) ? kRequestPartialStart : userRequest; //Kludge for now. NJE 6/27/13

    /// loop through the data structures and see if data exists, filling vectors of requested frame and batch positions ...
    /// a bit ugly
    dataObjectInfo.requestBatchStartList = std::vector<int> (30); // vectors for answer...
    dataObjectInfo.requestBatchEndList   = std::vector<int> (30);
    dataObjectInfo.requestFrameStartList = std::vector<int> (30);
    dataObjectInfo.requestFrameEndList   = std::vector<int> (30);
    //  requstinDI            = std::vector<bool> (dataObjectInfo.dataStructures.size());

    // loop over decoded datastructure
    int structure,numfullbatches,count;
    count=0;
    for(int i = 0; i< dataObjectInfo.dataStructures.size(); ++i)
    {
        structure = (int)floor((float)dataObjectInfo.dataStructures[i]/10); /// decode dat structre and test
        numfullbatches =dataObjectInfo.dataStructures[i]-structure*10;
        //std::cout << "structure " <<  structure << std::endl;
        //std::cout << "numfullbatches " <<  numfullbatches << std::endl;
        switch(request)
        {
            case kRequestPartialStart:
                if(structure == 1 || structure == 3)
                {
                    dataObjectInfo.requestFrameStartList[count] = dataObjectInfo.DISigFrames[i]; // add in start frame for DI
                    dataObjectInfo.requestFrameEndList[count]   = dataObjectInfo.DISigFrames[i+1]-1; // add end frame for that DI
                    dataObjectInfo.requestBatchStartList[count] = 0;
                    dataObjectInfo.requestBatchEndList[count]   = dataObjectInfo.batchEndPos[i][0];
                    ++count;
                    //requstinDI[i]=true;
                }
                break;
            case kRequestFull1:
                if( numfullbatches > 0 )
                {
                    fillRequestPosVectors(structure, i, count , 1);
                    ++count;
                }
                break;
            case kRequestFull2:
                if( numfullbatches > 1 )
                {
                    fillRequestPosVectors(structure, i, count , 2);
                    ++count;
                }
                break;
            case kRequestFull3:
                if( numfullbatches > 2 )
                {
                    fillRequestPosVectors(structure, i, count , 3);
                    ++count;
                }
                break;
            case kRequestFull4:
                if( numfullbatches > 3 )
                {
                    fillRequestPosVectors(structure, i, count , 4);
                    ++count;
                }
                break;
            case kRequestFull5:
                if( numfullbatches > 4 )
                {
                    fillRequestPosVectors(structure, i, count , 5);
                    ++count;
                }
                break;
            case kRequestFull6:
                if( numfullbatches > 5 )
                {
                    fillRequestPosVectors(structure, i, count , 6);
                    ++count;
                }
                break;
            case kRequestPartialEnd:
                if(structure == 1 || structure == 4)
                {
                    dataObjectInfo.requestFrameStartList[count] = dataObjectInfo.DISigFrames[i]; // add in start frame for DI
                    dataObjectInfo.requestFrameEndList[count]   = dataObjectInfo.DISigFrames[i+1]-1; // add end frame for that DI
                    dataObjectInfo.requestBatchStartList[count] = dataObjectInfo.batchStartPos[i][dataObjectInfo.batchStartPos[i].size()-1];
                    dataObjectInfo.requestBatchEndList[count]   = dataObjectInfo.sp.ptsPerFrame;
                    ++count;
                   // requstinDI[i]=true;
                }
               // else{requstinDI[i]=false;}
                break;
            case kRequestAll: /// NEED TO HANDLE THIS CASE THIS IN A BETTER WAY
               // if(structure != 0 && structure != 0) requstinDI[i]=true;
               // else{requstinDI[i]=false;}
            break;
        };
    }
    //std::cout << "count " <<  count << std::endl;
    if(count < 1 ) return false; // this means only one frame or less found which is an error
    dataObjectInfo.requestFrameStart = dataObjectInfo.requestFrameStartList[0];
    dataObjectInfo.requestFrameEnd   = dataObjectInfo.requestFrameEndList[0];
    dataObjectInfo.requestBatchStart = dataObjectInfo.requestBatchStartList[0];
    dataObjectInfo.requestBatchEnd   = dataObjectInfo.requestBatchEndList[0];
    /// now we can loop through the selected positions and test their consistancy (i.e. has the start poisition slipped or a gap in the selected frames
    /// Execuative decision assume first positiosn are correct and go from there... Carelessly, we loose the last frame with this method... :o(
    for(int i=1;i < count; ++i)
    {
        if( abs(dataObjectInfo.requestBatchStartList[i]-dataObjectInfo.requestFrameStart) > 2*dataObjectInfo.bucketLength
           ||
           abs(dataObjectInfo.requestBatchEndList[i]-dataObjectInfo.requestBatchEnd) > 2*dataObjectInfo.bucketLength) break;
        // move batch start pos to largest range possible
        if(dataObjectInfo.requestBatchStartList[i] < dataObjectInfo.requestBatchStart) dataObjectInfo.requestBatchStart = dataObjectInfo.requestBatchStartList[i];
        if(dataObjectInfo.requestBatchEndList[i] > dataObjectInfo.requestBatchEnd) dataObjectInfo.requestBatchEnd = dataObjectInfo.requestBatchEndList[i];
        if( dataObjectInfo.requestFrameStartList[1]-1 > dataObjectInfo.requestFrameEnd) break;
        dataObjectInfo.requestFrameEnd=dataObjectInfo.requestFrameEndList[i];
    }
    //std::cout << "frames and positions  " <<  dataObjectInfo.requestFrameStart << " " << dataObjectInfo.requestFrameEnd << "  " << dataObjectInfo.requestBatchStart << " " <<  dataObjectInfo.requestBatchEnd << std::endl;
    return true;
}

void ppDataObject::fillRequestPosVectors(int structure, int i, int count ,int batch)
{
    dataObjectInfo.requestFrameStartList[count] = dataObjectInfo.DISigFrames[i]; // add in start frame for DI
    dataObjectInfo.requestFrameEndList[count] = dataObjectInfo.DISigFrames[i+1]-1; // add end frame for that DI
    /// structure 1 = partial symmetric, 2 = full symmetric, 3 = asymmetric partial at start, 4 asymetric partial at end
    switch(structure)
    {
        case 1:
            dataObjectInfo.requestBatchStartList[count] =  dataObjectInfo.batchStartPos[i][batch-1];
            dataObjectInfo.requestBatchEndList[count]   =  dataObjectInfo.batchEndPos[i ][batch];
            break;
        case 2:
            dataObjectInfo.requestBatchStartList[count] =  dataObjectInfo.batchStartPos[i][batch-1];
            dataObjectInfo.requestBatchEndList[count]   =  dataObjectInfo.batchEndPos[i ][batch-1];
            break;
        case 3:
            dataObjectInfo.requestBatchStartList[count] =  dataObjectInfo.batchStartPos[i][batch-1];
            dataObjectInfo.requestBatchEndList[count]   =  dataObjectInfo.batchEndPos[i][batch];
            break;
        case 4:
            dataObjectInfo.requestBatchStartList[count] =  dataObjectInfo.batchStartPos[i][batch-1];
            dataObjectInfo.requestBatchEndList[count]   =  dataObjectInfo.batchEndPos[i ][batch-1];
            break;
    }
}

void ppDataObject::getSumFrame()
{
    sumFrames = std::vector<long int> ( dataObjectInfo.requestBatchEnd - dataObjectInfo.requestBatchStart + 1 );

    for( int j = 0; j<sumFrames.size(); ++j )
    {
        for( int i = dataObjectInfo.requestFrameStart; i < dataObjectInfo.requestFrameEnd+1; ++i )
        {
            sumFrames[j] += rawData[ dataObjectInfo.requestBatchStart + i*dataObjectInfo.sp.ptsPerFrame + j];
        }
    }
    #ifdef _PREPOCESSER_VERBOSE
        std::cout << "\t ===== getSumFrame ===== "<< std::endl;
        std::cout << std::endl;
        std::cout << "\tinfo. " << std::endl;
        std::cout << "\tptsPerFrame = " << dataObjectInfo.sp.ptsPerFrame;
        std::cout << "    requestFrameStart = " << dataObjectInfo.requestFrameStart << std::endl;
        std::cout << "\trequestFrameEnd = " << dataObjectInfo.requestFrameEnd;
        std::cout << "   sumFrames.size() " << sumFrames.size() <<  std::endl;
        std::cout << std::endl;
        std::cout << "\tCalculating sumFrames, the first few are: " <<  std::endl;
        std::cout << std::endl;
        std::cout << "\t";
        for(int i = 0; i < 10; ++i)
        std::cout << sumFrames[i] << " " ;
        std::cout  << std::endl;
        std::cout << std::endl;
    #endif
}

void ppDataObject::getProfiles(std::vector<float >& profiles,  profile_data_header_type * profHeader)
{
    ppProfileGenerator * profileGenerator;
    profileGenerator = new ppProfileGenerator( dataObjectInfo.requestFrameStart, dataObjectInfo.requestFrameEnd, dataObjectInfo.requestBatchStart, dataObjectInfo.requestBatchEnd, &dataObjectInfo );

    profileGenerator->getProfiles( profiles, rawData, dataObjectInfo.bunchMids );
    profileGenerator->getProfHeader( profHeader );

    delete profileGenerator;
}

void ppDataObject::writeReallyRawData( const char* fileName )
{
    //This header should be a DAQStruct
    DAQStruct rawHeader;
    sprintf( rawHeader.title, "test title" );
    for(int i = 0; i < 14; ++i ) rawHeader.time[i] = 0;

    rawHeader.DAQScope = dataObjectInfo.sp;
    rawHeader.DAQTrig  = dataObjectInfo.ppTrigInfo;

    writeRawDataFile( fileName, &rawHeader, &reallyRawData[0] );
}
