#ifndef PPDATAOBJECT_H
#define PPDATAOBJECT_H

#include <vector>
#include <iostream>

//#include "ppStruct.h"
#include "TomographyStructs.h"
#include "TomographyConfig.h"
//#include "TomographyStructDefaults.h"

#include "ppFrameSignalFinder.h"
#include "ppDIFrameFinder.h"
#include "ppBatchPosFinder.h"
#include "ppBunchMidFinder.h"
#include "ppProfileGenerator.h"

class ppDataObject
{
    public:

        ppDataObject(const unsigned char * inData, const Machine_Config * mcIN, const scopeParam * spIN, const ppStruct * ppSIN);
        ppDataObject( const char* filename, const Machine_Config* machine, const ppStruct* pps);
        ~ppDataObject();

        //void changeParam(const ppStruct * ppS);
        void changeParam(const Machine_Config * mcIN, const scopeParam * spIN, const ppStruct * ppsIN);
        void setTrigInfo(const trigParam* info);
        void getHeaderTrigParams( profile_data_header_type * head );

        int analyseData();
        void getAnalysisResults(std::vector<int>& foranswer);
        bool profilesRequestHandler(std::vector<float >& profiles, profile_data_header_type * profHeader, const profileRequests request=kRequestDefault );

        void writeReallyRawData(const char* fileName);
        const ppDataObjectInfo getPPDataObjectInfo(){ return dataObjectInfo; };

    protected:

    private:

        ppDataObjectInfo dataObjectInfo; /// all info associated with this data should be in here, input and output

        std::vector<unsigned char> reallyRawData;
        std::vector<int> rawData;
        float bucketlength;

        /// Signal finder
        bool findSignal();

        /// DI frame finder
        bool findDIFrames( int *numDIFound );

        /// Batch pos finder
        bool findBatchPos();
        void decodeBatchPosDataStructures();

        /// Profile Reqests
        bool dataExists(const profileRequests request);
        void fillRequestPosVectors(int structure, int i, int count ,int batch);

        std::vector<long int> sumFrames;
        void getSumFrame();
        void getProfiles(std::vector<float >& profiles,  profile_data_header_type * profHeader);


       // ClassDef(ppDataObject,0);
};

#endif
//PPDATAOBJECT_H

