#include "ppFrameSignalFinder.h"

    ppFrameSignalFinder::ppFrameSignalFinder(const  int numFrames, const  int ptsPerFrame)
    {
        localNumFrames = numFrames;
        localPtsPerFrame = ptsPerFrame;
    }

    ppFrameSignalFinder::~ppFrameSignalFinder()
    {
       // dtor
    }

    bool ppFrameSignalFinder::findSignal(std::vector<int> & data, const float trigger, int * frameSigStart, int * sigEndFrame)
    {
        localFrameStart = findStartFrame(data.begin(), trigger);
        if( localFrameStart+1 == localNumFrames) // no signal found
        {
            return false;
        }
        else
        {
            localframeStop = findStopFrame(data.end(), trigger);
            *frameSigStart = localFrameStart;
            *sigEndFrame = localframeStop;
            return true;
        }
    }
    int ppFrameSignalFinder::findStartFrame(std::vector<int>::iterator startit, float trigger)
    {
        bool hasSignal;
        hasSignal = false;
        for(i = 0 ; i < localNumFrames-1 ; ++i)
        {
            hasSignal = sigTest(startit, i*localPtsPerFrame, (i+1)*localPtsPerFrame, trigger);
            if(hasSignal)
            {
                break;
            }
        }
        return i;
    }
    int ppFrameSignalFinder::findStopFrame(std::vector<int>::iterator endit, float trigger)
    {
        bool hasSignal;
        hasSignal = false;
        for(i = 0 ; i < localNumFrames-1 ; ++i)
        {
            hasSignal = sigTest(endit, - (i+1)*localPtsPerFrame, -i*localPtsPerFrame, trigger);
            if(hasSignal)
            {
                break;
            }
        }

        return localNumFrames-i-1;
    }
    bool ppFrameSignalFinder::sigTest(std::vector<int>::iterator startit, int start, int stop, float trigger)
    {
        bool signalQ;
        double mean = getMean(startit,  start, stop);
        double max  = (double)getMax(startit, start, stop);
        signalQ = ( max/mean > (double)trigger ) ? true : false;
        // if( max/mean > (double)trigger )
        // {
        //     signalQ = true;
        // }else{
        //     signalQ = false;
        // }
        return signalQ;
    }
    double ppFrameSignalFinder::getMean(std::vector<int>::iterator startit, int start, int stop)
    {
        return TMath::Mean(startit + start, startit + stop);
    }
    int ppFrameSignalFinder::getMax(std::vector<int>::iterator startit, int start, int stop)
    {
        std::vector<int>::iterator ans = TMath::LocMax(startit + start, startit + stop);
        return *ans;
    }


