#ifndef PPFRAMESIGNALFINDER_H
#define PPFRAMESIGNALFINDER_H

#include <iostream>
#include <vector>

// Simple root Maths stuff
#include "TMath.h"
//#include <TObject.h>

class ppFrameSignalFinder
{
    public:
        ppFrameSignalFinder(const  int numFrames, const  int ptsPerFrame);
        ~ppFrameSignalFinder();

        bool findSignal(std::vector<int> & data, const float trigger, int * frameSigStart, int * sigEndFrame);

    protected:
    private:
        int i;
        int localNumFrames, localPtsPerFrame;
        int localFrameStart,localframeStop;
        
        /// Gen Math from Root
        double getMean(std::vector<int>::iterator startit, int start, int stop);
        int    getMax(std::vector<int>::iterator startit, int start, int stop);

        int findStartFrame(std::vector<int>::iterator startit, float trigger);
        int findStopFrame(std::vector<int>::iterator startit, float trigger);
        bool sigTest(std::vector<int>::iterator startit, int start, int stop, float trigger);

 //ClassDef(ppFrameSignalFinder,0);
};

#endif // PPFRAMESIGNALFINDER_H
