#ifndef PPPROFILEGENERATOR_H
#define PPPROFILEGENERATOR_H

#include <vector>

#include <iostream>
#include <map>
#include <algorithm>
#include <math.h>

#include "TomographyStructs.h"
//#include "TomographyStructDefaults.h"
//#include "ppStruct.h"

class ppProfileGenerator
{
    public:
        ppProfileGenerator(int requestFrameStart, int requestFrameEnd, int requestBatchStart, int requestBatchEnd, const ppDataObjectInfo * DataObjectInfo);
        ~ppProfileGenerator();

        bool getProfiles(std::vector <float> & profiles, std::vector <int> & rawData, std::vector <float> & bunchMids);
        void getProfHeader(profile_data_header_type * profHeader);


    protected:
    private:

        ppStruct localPPP;

        int     localFrameStart, localFrameEnd, localBatchStart, localBatchEnd,localPtsPerFrame,localPtsPerProf,localnumBunches;
        float localBucketLength,localInterval;

        bool simpleProf(std::vector <float> & profiles, std::vector <int> & rawData, std::vector <float> & bunchMids);
        bool interProf(std::vector <float> & profiles, std::vector <int> & rawData, std::vector <float> & bunchMids);

        void getFrameBaseline(std::vector<int >& inData);
        void removeProfileBaseLin(std::vector<float >& profiles);
        std::vector<int> baseline;

        int roundPos(float in) {   return (int)floor(in + 0.5); }
        struct mode_predicate;
        int Commonest(std::vector<int>::iterator start);
        void getCommonest(std::vector<int >& inData, std::vector<int >& outData);

        //ClassDef(ppProfileGenerator,0);
};



#endif // PPPROFILEGENERATOR_H
