#ifndef _TomographyStructDefaults
#define _TomographyStructDefaults
#include "TomographyStructs.h"

namespace defaultSettings
{

//Machines and Tomography

	Machine_Config injectionMI()
	{
		Machine_Config injection_MI;
		injection_MI.h      = 588       ;
		injection_MI.eKin   = 8E9       ;
		injection_MI.mass   = 938272064 ;
		injection_MI.RF_V   = 150E3     ;
		injection_MI.RF_f   = 52.8114E6 ;
		injection_MI.gammaT = 21.838    ;
		injection_MI.synPhi = 0.0       ;
		return injection_MI;
	};
	Machine_Config injectionRR()
	{
		Machine_Config injection_RR;
		injection_RR.h      = 588       ;
		injection_RR.eKin   = 8E9       ;
		injection_RR.mass   = 938272064 ;
		injection_RR.RF_V   = 150E3     ;
		injection_RR.RF_f   = 52.8114E6 ;
		injection_RR.gammaT = 21.838    ;
		injection_RR.synPhi = 0.0       ;
		return injection_RR;
	};
	Tomography_Config standardTomo()
	{
		Tomography_Config standard_Tomo;
		standard_Tomo.MaxIterations       = 10        ;
		standard_Tomo.SqrtPPP             = 1         ;
		standard_Tomo.Frames              = 100       ;
		standard_Tomo.ReconstructionFrame = 0         ;
		standard_Tomo.ConvergenceLimit    = 1E-6      ;
		standard_Tomo.dampingFactor       = 1.0       ;
		standard_Tomo.algorithm           = kFCART_ID ;
		return standard_Tomo;
	};

}
// //View Formats
// plotFormat defaultData;
// defaultData.plotType      = kData;
// defaultData.padXMin       = 0.0;
// defaultData.padYMin       = 0.0;
// defaultData.padXMax       = 0.33;
// defaultData.padYMax       = 0.5;
// defaultData.startBunch    =   0;
// defaultData.endBunch      =   5;
// defaultData.bunchesPerRow =   5;
// defaultData.contours.clear();
// defaultData.numberOfContours = defaultDataOpts.contours.size();

// plotFormat defaultProj;
// defaultProj.plotType = kProj;
// defaultProj.padXMin       = 0.33;
// defaultProj.padYMin       = 0.0;
// defaultProj.padXMax       = 0.66;
// defaultProj.padYMax       = 0.5;
// defaultProj.startBunch    =   0;
// defaultProj.endBunch      =   5;
// defaultProj.bunchesPerRow =   5;
// defaultProj.contours.clear();
// defaultProj.numberOfContours = defaultProj.contours.size();

// plotFormat defaultImage;
// defaultImage.plotType = kImage;
// defaultImage.padXMin       = 0.66;
// defaultImage.padYMin       = 0.0;
// defaultImage.padXMax       = 1.0;
// defaultImage.padYMax       = 0.5;
// defaultImage.startBunch    =   0;
// defaultImage.endBunch      =   5;
// defaultImage.bunchesPerRow =   5;

// defaultImage.contours.clear();
// //defaultImage.contours.push_back(8.0);
// defaultImage.numberOfContours = defaultImage.contours.size();

// plotFormat defaultEmittanceHisto;
// defaultEmittanceHisto.plotType = kEmittanceHisto;
// defaultEmittanceHisto.padXMin       = 0.0;
// defaultEmittanceHisto.padYMin       = 0.5;
// defaultEmittanceHisto.padXMax       = 1.0;
// defaultEmittanceHisto.padYMax       = 1.0;
// defaultEmittanceHisto.startBunch    =   0;
// defaultEmittanceHisto.endBunch      =   5;
// defaultEmittanceHisto.bunchesPerRow =   5;
// defaultEmittanceHisto.contours.clear();
// defaultEmittanceHisto.numberOfContours = defaultEmittanceHisto.contours.size();


#endif

